summaryrefslogtreecommitdiffstats
path: root/src/lib/connections/bridge
diff options
context:
space:
mode:
authorJouke Witteveen <j.witteveen@gmail.com>2012-12-28 02:38:58 +0100
committerJouke Witteveen <j.witteveen@gmail.com>2012-12-28 02:38:58 +0100
commit4e457e0efd0e5fd5df24c7e9ed63b02d0196ea8d (patch)
tree09580c92ca78e8b9b54d7ed8d6b79d7fcd6fd9ff /src/lib/connections/bridge
parent6737a37e5666837a8f51a2f74bdebdd756151394 (diff)
downloadnetctl-4e457e0efd0e5fd5df24c7e9ed63b02d0196ea8d.tar.gz
netctl-4e457e0efd0e5fd5df24c7e9ed63b02d0196ea8d.tar.xz
Forking netcfg to netctl (1/2)
This commit contains the moving of files.
Diffstat (limited to 'src/lib/connections/bridge')
-rw-r--r--src/lib/connections/bridge47
1 files changed, 47 insertions, 0 deletions
diff --git a/src/lib/connections/bridge b/src/lib/connections/bridge
new file mode 100644
index 0000000..6b3ab67
--- /dev/null
+++ b/src/lib/connections/bridge
@@ -0,0 +1,47 @@
+#! /bin/bash
+. /usr/lib/network/network
+BRCTL="/usr/sbin/brctl"
+
+bridge_up() {
+ local bridge_interface
+ load_profile "$1"
+
+ if [[ -e "/sys/class/net/$INTERFACE" ]]; then
+ if [[ ! -d "/sys/class/net/$INTERFACE/brif" ]]; then
+ report_fail "Interface $INTERFACE already exists and is not a bridge."
+ exit 1
+ fi
+ else
+ $BRCTL addbr "$INTERFACE"
+ fi
+
+ for bridge_client in $BRIDGE_INTERFACES; do
+ ip link set "$bridge_client" promisc on up
+ ip addr flush dev "$bridge_client"
+ $BRCTL addif "$INTERFACE" "$bridge_client"
+ done
+ # Set options
+ [[ "$FWD_DELAY" ]] && $BRCTL setfd "$INTERFACE" "$FWD_DELAY"
+ [[ "$MAX_AGE" ]] && $BRCTL setmaxage "$INTERFACE" "$MAX_AGE"
+
+ "$CONN_DIR/ethernet" up "$1"
+ return 0
+}
+
+bridge_down() {
+ local bridge_interface
+ load_profile "$1"
+
+ for bridge_client in $BRIDGE_INTERFACES; do
+ ip link set "$bridge_client" promisc off down
+ $BRCTL delif "$INTERFACE" "$bridge_client"
+ done
+
+ "$CONN_DIR/ethernet" down "$1"
+ $BRCTL delbr "$INTERFACE"
+ return 0
+}
+
+bridge_$1 "$2"
+exit $?
+# vim: set ts=4 et sw=4: